﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.Runtime.InteropServices;
using Microsoft.Win32;
using System.Security.Permissions;
using System.Security;

namespace SciLor_s_Mashed_Runner {
    class Mashed {

        [DllImport("user32.dll")]
        private static extern void SwitchToThisWindow(IntPtr hWnd, bool fAltTab);

        public const String EMPTY_VIDEO = "SciLorsEmptyVideo.mpg";
        public const String BASE_VIDEO_DIR = @"TOASTART\PC\MOVIES\";
        public static String[] VIDEO_NAMES = { 
                                                  "empire.mpg",
                                                  "intro.mpg",
                                                  "renderware.mpg",
                                                  "small.mpg",
                                                  "supersonic.mpg"
                                              };

        public const String EXE = "MFL.exe";
        public const String LAUNCHER = "launch.exe";
        public const String SAVE = ""; //@"save\";

        public static IconFile[] ICOS = {
            new IconFile(@"TOASTART\Common\PANEL\NFLRed.png"),
            new IconFile(@"TOASTART\Common\PANEL\NFLBluejay.png"),
            new IconFile(@"TOASTART\Common\PANEL\NFLGold.png"),
            new IconFile(@"TOASTART\Common\PANEL\NFLMelon.png"),
            new IconFile(@"TOASTART\Common\PANEL\NFLPink.png"),
            new IconFile(@"TOASTART\Common\PANEL\NFLShadow.png"),
                                              };

        public const String ICO = @"TOASTART\Common\PANEL\NFLRed.png";
        public const String ICO_SMALL = "mashed.ICO";



        public static ByteMask[] SearchPatternNoCD = {
            new ByteMask("FF 90 0C 07 00 00 3B C3 7D 12 68 0C 07 00 00 68 5C 43 4E 00 56 50 FF 15 50 10 40 00 83 C8 FF 66"), //Messagebox 
            new ByteMask("0F 85 54 02 00 00 8B 17 8B 3D 40 10 40 00 52 68 90 49 4E 00 66 89 86 A8 00 00 00 FF D7 8B D0 8D"), //Do not run
                                                };
        public static ByteMask[] ReplacePatternNoCD = {
            new ByteMask("90 ?? 90 90 90 90 ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ??"), //NOP it out ;)
            new ByteMask("EB 04 90 90 90 90 ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ?? ??"), //JMP always :P
                                                };
        private const String REGISTRY_BASE = "empire interactive";
        private const String REGISTRY_MFL = "mfl";

        public static void Run(bool video, bool control, bool exit, frmMashed form) { //-VS0 -CS0 -L1
            if (!checkExe()) return;
            form.Enabled = false;
            //form.WindowState = FormWindowState.Minimized;

            int lang = 0;
            if (form.cmbLanguage.SelectedItem != null) {
                Language langObj = (Language)form.cmbLanguage.SelectedItem;
                lang = langObj.Id;
            }

            Process p = new Process();
            p.StartInfo.FileName = Properties.Settings.Default.Path + Mashed.EXE;
            p.StartInfo.Arguments = "-VS" + bool2int(video) + " " + "-CS" + bool2int(control) + " " + "-L" + lang;
            p.StartInfo.WorkingDirectory = Properties.Settings.Default.Path + Mashed.SAVE;
            p.Start();

            if (exit) {
                form.Close();
                Application.Exit();
            } else {
                p.WaitForExit();
                form.Enabled = true;
                form.Refresh();
                if (form.WindowState != FormWindowState.Minimized) 
                    form.WindowState = FormWindowState.Minimized;
                //form.WindowState = FormWindowState.Normal;
                SwitchToThisWindow(form.Handle, true);
                form.Show();

            }
        }
        private static int bool2int(bool value) {
            if (value) return 1;
            return 0;
        }

        private static RegistryKey getRegistryBase() {
            RegistryKey baseKey = Registry.LocalMachine.OpenSubKey("Software", true);
            return baseKey.CreateSubKey(REGISTRY_BASE).CreateSubKey(REGISTRY_MFL);
        }
        public static bool setRegistryInstallation(String path) {
            try {
                RegistryKey mfl = getRegistryBase();
                mfl.DeleteValue("installpath", false);
                mfl.SetValue("installpath", path, RegistryValueKind.String);
                mfl.DeleteValue("installstatus", false);
                mfl.SetValue("installstatus", "2", RegistryValueKind.String);

                mfl.Close();
                return true;
            } catch (SecurityException) {}
            return false;
        }
        public static bool setRegistryLanguage(Language lang) {
            try {
                RegistryKey mfl = getRegistryBase();
                mfl.SetValue("language", lang.Identifier, RegistryValueKind.String);
                mfl.Close();
            } catch (SecurityException) { }
            return false;
        }

        public static bool checkExe() {
            if (!System.IO.File.Exists(Util.GetMashedDir() + Mashed.EXE)) {
                MessageBox.Show(Mashed.EXE + " " + "not found" + "\r\n" +
                    "Please copy this application into the Mashed - Fully Loaded directory" + "\r\n" +
                    "or select the right path to its executable.",
                    "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return false;
            }
            return true;
        }
    }
}
